/***************************************************************************
			wancfglib_chan_def.h  -  description
			-------------------
			begin                : Tue Mar 16 2004
			copyright            : (C) 2004 by David Rokhvarg
			email                : davidr@sangoma.com
***************************************************************************/

/***************************************************************************
*                                                                         *
*   This program is free software; you can redistribute it and/or modify  *
*   it under the terms of the GNU General Public License as published by  *
*   the Free Software Foundation; either version 2 of the License, or     *
*   (at your option) any later version.                                   *
*                                                                         *
***************************************************************************/

#ifndef WANCFGLIB_CHAN_DEF_H
#define WANCFGLIB_CHAN_DEF_H

#include "stdafx.h"
#include "wancfglib.h"
#include "wanconfig.h"

#include <vector>

//must be shorter than 'WAN_IFNAME_SZ+1'
#define CHAN_NOT_CONFIGURED "chan_not_cfgd"
#define MAX_ADDR_STR_LEN	100
#define MAX_LEN_OF_ACTIVE_CHANNELS_STRING 100

/**
*@author David Rokhvarg
*/

class wancfglib_chan_def {

public:
	char *tmp_conf;
	//////////////////////////////////////////////////////////////////////////////////////
	chan_def_t if_data;

	//////////////////////////////////////////////////////////////////////////////////////
	link_def_t link_defs;	//Port/Line configuration at HARDWARE level
							//OR
							//Profile (global Protocol) configuration at PROTOCOL level.
							//This is for case an INTERFACE is in STACK mode.

	unsigned int card_version;		/* there are many versions of S514: S514-1/2/3/...7 */
	unsigned int card_sub_version;	/* AFT can be "Shark" or "non-Shark" */
	char firmware_file_path[MAX_PATH_LENGTH];/* for S514 cards only - the '.sfm' file */

	//If this interface is in STACK mode, 'next_objects_list' will be non-empty.
	std::vector<wancfglib_chan_def*> next_objects_list;

	wancfglib_chan_def();
	virtual ~wancfglib_chan_def();

	int compare(wancfglib_chan_def* element);
	int compare(char* comparator);
	char* get_comparator();
	void set_comparator(char* comparator);
};

#endif//WANCFGLIB_CHAN_DEF_H

