//////////////////////////////////////////////////////////////////////
// wp_hwprobe.h: interface for the wp_hwprobe class.
//
// Author	:	David Rokhvarg	<davidr@sangoma.com>
//////////////////////////////////////////////////////////////////////

#pragma once

#include "stdafx.h"
#include "wanpipe_includes.h"
#include "wanpipe_defines.h"
#include "wanpipe_cfg_defines.h"
#include "libsangoma.h"
#include "wanpipe_api.h"


#include <string>
#include <vector>

namespace wanrouter{

typedef struct sdla_hw_type_cnt{

	unsigned char s518_adapters;
	unsigned char aft101_adapters;
	unsigned char aft104_adapters;
	unsigned char aft300_adapters;
	unsigned char aft200_adapters;
	unsigned char aft108_adapters;
	unsigned char aft_isdn_adapters;
	unsigned char aft_56k_adapters;
	unsigned char aft_serial_adapters;
	unsigned char aft_a600_adapters;
	unsigned char aft_b601_adapters;
	unsigned char aft_a700_adapters;
	
	unsigned char aft_x_adapters;
	unsigned char usb_adapters;
}sdla_hw_type_cnt_t;

class wp_hwprobe
{
	struct {
		char hwprobe_str[WP_MAX_HW_PROBE_STR_LEN];
		sdla_hw_type_cnt_t sdla_hw_type_cnt;
	}wp_hwprobe_priv;

#define HW_STR	wp_hwprobe_priv.hwprobe_str
#define HW_CNTR	wp_hwprobe_priv.sdla_hw_type_cnt

	std::vector <hardware_info_t> hw_info_vec;
	char cVerbose;

	void wp_get_port_count_summary(std::string & strPortSummary);
	int scan_for_sangoma_ports();
	int add_port(hardware_info_t & new_hw_info);
	int run(std::string & strProbeList);
	int get_remora_modules(hardware_info_t & hwinfo, std::string & strInterfacesProbeList);

public:
	wp_hwprobe(void);
	~wp_hwprobe(void);
	int get_hwprobe_str(char *destination_buffer, int buffer_size, char verbose);
};

}//end of namespace wanrouter
